//
// This SC software has been created by MarHazK
// You can get more Sources at www.hazlicyber.cjb.net
//
//

#include "stdafx.h"

#include <conio.h>  //Function used: outport(port,value),getch()
#include <stdio.h>  //Function used: printf,scanf
#include <ctype.h>  //Function used: toupper
#include <tlhelp32.h>
#include <winsvc.h> //Function for Services

#include "ircsc.h"

extern "C" {
	void __stdcall LoadDll (LOADINFO *loadInfo) {
		return;
	}
	int __stdcall UnloadDll (int mTimeout) {
		if (mTimeout == 1) {
			return(0);
		}
		return(1);
	}

	// Just send an ECHO commands for mIRC.
	int __stdcall stop (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		SERVICE_STATUS status;
		SC_HANDLE hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		SC_HANDLE hService = OpenService(hSCManager, data, SERVICE_STOP); 
		ControlService(hService, SERVICE_CONTROL_STOP, &status);
		strcpy(data, "KILLED");
		CloseServiceHandle(hService);
		CloseServiceHandle(hSCManager);
		return(3);
	}
	int __stdcall start (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		SC_HANDLE hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		SC_HANDLE hService = OpenService(hSCManager, data, SERVICE_START); 
		if (StartService(hService, 0, NULL)) 
		{
			strcpy(data, "START_SUCCESS");
		}
		else {
			strcpy(data, "START_FAILED");
		}
		CloseServiceHandle(hService);
		CloseServiceHandle(hSCManager);
		return(3);
	}
	int __stdcall restart (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		SERVICE_STATUS status;
		SC_HANDLE hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		SC_HANDLE hService = OpenService(hSCManager, data, SERVICE_STOP|SERVICE_START); 
		ControlService(hService, SERVICE_CONTROL_STOP, &status);
		if (StartService(hService, 0, NULL)) 
		{
			strcpy(data, "RESTART_SUCCESS");
		}
		else {
			strcpy(data, "RESTART_FAILED");
		}
		CloseServiceHandle(hService);
		CloseServiceHandle(hSCManager);
		return(3);
	}
	// Proccessed under MarHazK via COMMAND SEND...
	int __stdcall stopProc (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		SERVICE_STATUS status;
		SC_HANDLE hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		SC_HANDLE hService = OpenService(hSCManager, data, SERVICE_STOP); 
		ControlService(hService, SERVICE_CONTROL_STOP, &status);
		strcpy(data, "KILLED");
		CloseServiceHandle(hService);
		CloseServiceHandle(hSCManager);
		return(4);
	}
	int __stdcall startProc (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		SC_HANDLE hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		SC_HANDLE hService = OpenService(hSCManager, data, SERVICE_START); 
		if (StartService(hService, 0, NULL)) 
		{
			strcpy(data, "START_SUCCESS");
		}
		else {
			strcpy(data, "START_FAILED");
		}
		CloseServiceHandle(hService);
		CloseServiceHandle(hSCManager);
		return(4);
	}
	int __stdcall restartProc (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		SERVICE_STATUS status;
		SC_HANDLE hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		SC_HANDLE hService = OpenService(hSCManager, data, SERVICE_STOP|SERVICE_START); 
		ControlService(hService, SERVICE_CONTROL_STOP, &status);
		if (StartService(hService, 0, NULL)) 
		{
			strcpy(data, "RESTART_SUCCESS");
		}
		else {
			strcpy(data, "RESTART_FAILED");
		}
		CloseServiceHandle(hService);
		CloseServiceHandle(hSCManager);
		return(4);
	}
	// Others Details (ADDITIONAL) by MarHazK
	int __stdcall version (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		strcpy(data, "IRCSC 1.0 - Copyright (C) 2002-2005 HazliCyber Corp. Ltd. by MarHazK. Download at www.hazlicyber.cjb.net");
		return(3);
	}
	int __stdcall test (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
		strcpy(data, "NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.NO TEST ALLOWED.\nNO TEST ALLOWED.");
		return(3);
	}
}

